<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/Scope.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/Scope.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/Scope.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> config</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> Parameter</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.TOC <span class="py-keyword">import</span> TOC</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.View <span class="py-keyword">import</span> View</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Parts <span class="py-keyword">import</span> *</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-keyword">import</span> time</span>
<a id="line17"></a><span class="lineno"> 17</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html">Scope</a>(View):</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    <span class="py-string">&quot;&quot;&quot;A module for creating a view for each Scope with summaries and</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="py-string">    details. This module is highly modular, using the classes from</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="py-string">    ASGFormatter to do the actual formatting. The classes to use may be</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="py-string">    controlled via the config script, resulting in a very configurable output.</span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-string">    @see ASGFormatter The ASGFormatter module</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line"><span class="py-string">    @see Config.Formatters.HTML.ScopeViews Config for ScopeViews</span></span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    parts = Parameter([Heading(),</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">                       Summary(),</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">                       Inheritance(),</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">                       Detail()],</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">                      <span class="py-string">''</span>)</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#register">register</a>(self, frame):</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">        super(Scope, self).register(frame)</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">        <span class="py-keyword">for</span> part <span class="py-keyword">in</span> self.parts: part.register(self)</span>
<a id="line37"></a><span class="lineno"> 37</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        self.scope_queue = []</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">        self.__toc = TOC(self.directory_layout)</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.processor.ir.asg.declarations:</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">            d.accept(self.__toc)</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#toc">toc</a>(self):</span>
<a id="line44"></a><span class="lineno"> 44</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        <span class="py-keyword">return</span> self.__toc</span>
<a id="line46"></a><span class="lineno"> 46</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#filename">filename</a>(self):</span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">        <span class="py-keyword">return</span> self.__filename</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#title">title</a>(self):</span>
<a id="line52"></a><span class="lineno"> 52</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-keyword">return</span> self.__title</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#root">root</a>(self):</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        <span class="py-keyword">if</span> self.main:</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">            url = self.directory_layout.index()</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">            url = self.directory_layout.scope(self.processor.root.name)</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        title = <span class="py-string">'Global %s'</span>%(self.processor.root.type.capitalize())</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        <span class="py-keyword">return</span> url, title</span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#scope">scope</a>(self):</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        <span class="py-string">&quot;&quot;&quot;return the current scope processed by this object&quot;&quot;&quot;</span></span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        <span class="py-keyword">return</span> self.__scope</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#process">process</a>(self):</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Creates a view for every Scope.&quot;&quot;&quot;</span></span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">        module = self.processor.root</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">        self.scopes_queue = [module]</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        <span class="py-keyword">while</span> self.scopes_queue:</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">            scope = self.scopes_queue.pop(0)</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">            self.process_scope(scope)</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">            scopes = [c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> scope.declarations <span class="py-keyword">if</span> isinstance(c, ASG.Scope)]</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">            self.scopes_queue.extend(scopes)</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">            forwards = [c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> scope.declarations</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">                        <span class="py-keyword">if</span> isinstance(c, ASG.Forward) <span class="py-keyword">and</span> c.specializations]</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">            <span class="py-comment"># Treat forward-declared class template like a scope if it has</span></span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">            <span class="py-comment"># specializations, since these are only listed in a Scope view.</span></span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">            <span class="py-comment"># Process them directly as they don't have child declarations.</span></span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">            <span class="py-keyword">for</span> f <span class="py-keyword">in</span> forwards:</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">                self.process_scope(f)</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#register_filenames">register_filenames</a>(self):</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Registers a view for every Scope.&quot;&quot;&quot;</span></span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        self.scopes_queue = [self.processor.root]</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">while</span> self.scopes_queue:</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            scope = self.scopes_queue.pop(0)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">            <span class="py-keyword">if</span> scope.name:</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">                filename = self.directory_layout.scope(scope.name)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">                filename = self.root()[0]</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">            self.processor.register_filename(filename, self, scope)</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">            scopes = [c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> scope.declarations <span class="py-keyword">if</span> isinstance(c, ASG.Module)]</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">            self.scopes_queue.extend(scopes)</span>
<a id="line101"></a><span class="lineno">101</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#process_scope">process_scope</a>(self, scope):</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Creates a view for the given scope&quot;&quot;&quot;</span></span>
<a id="line104"></a><span class="lineno">104</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">        <span class="py-comment"># Open file and setup scopes</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line">        self.__scope = scope.name</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        <span class="py-keyword">if</span> self.__scope:</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">            self.__filename = self.directory_layout.scope(self.__scope)</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">            self.__title = escape(str(self.__scope))</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">            self.__filename, self.__title = self.root()</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        self.start_file()</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        self.write_navigation_bar()</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        <span class="py-comment"># Loop throught all the view Parts</span></span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-keyword">for</span> part <span class="py-keyword">in</span> self.parts:</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">            part.process(scope)</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">        self.end_file()</span>
<a id="line118"></a><span class="lineno">118</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/Scope/Scope.html#end_file">end_file</a>(self):</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Overrides end_file to provide synopsis logo&quot;&quot;&quot;</span></span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        self.write(<span class="py-string">'\n'</span>)</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        now = time.strftime(<span class="py-string">r'%c'</span>, time.localtime(time.time()))</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        logo = img(src=rel(self.filename(), <span class="py-string">'synopsis.png'</span>), alt=<span class="py-string">'logo'</span>)</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">        logo = href(<span class="py-string">'http://synopsis.fresco.org'</span>, logo + <span class="py-string">' synopsis'</span>, target=<span class="py-string">'_blank'</span>)</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        logo += <span class="py-string">' (version %s)'</span>%config.version</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        self.write(div(<span class="py-string">'logo'</span>, <span class="py-string">'Generated on '</span> + now + <span class="py-string">' by \n&lt;br/&gt;\n'</span> + logo))</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">        View.end_file(self)</span>
<a id="line129"></a><span class="lineno">129</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
